public class Sort {

    /**
     * The quicksort algorithm.  Optimized to do only n comparisons
     * for an array of size n.
     */ 
    public static void quicksort(long[] a, int lower, int upper) {
        if (lower >= upper) return;     // Base case
        
        int splitIndex = lower + (upper - lower) / 2;   // Keep track of
        long s = a[splitIndex];      // s is splitting element

        int i = lower, j = upper;
        while (j >= i) {	     // The partitioning loop
            while (j >= i && a[j] > s) j--;
            while (i < j && a[i] <= s) i++;
            if (i < j) {
                interchange(a, i, j);
		// See if we moved the splitting element
                if (j == splitIndex) splitIndex = i;
                j--; i++;
            }
            else if (i == j) i++;    // Must do this for loop to terminate
        }
        interchange(a, j, splitIndex);  // Put splitting element in place
        quicksort(a, lower, j-1);       // Recursive calls
        quicksort(a, j+1, upper);
    }

    public static void interchange(long[] a, int i, int j) {
        long temp = a[i];
        a[i] = a[j];
        a[j] = temp;
    }
}
